/*
 * Vikunja API
 *
 * This is the documentation for the [Vikunja](http://vikunja.io) API. Vikunja is a cross-plattform Todo-application with a lot of features, such as sharing lists with users or teams. <!-- ReDoc-Inject: <security-definitions> --> # Authorization **JWT-Auth:** Main authorization method, used for most of the requests. Needs `Authorization: Bearer <jwt-token>`-header to authenticate successfully.  **BasicAuth:** Only used when requesting tasks via caldav. <!-- ReDoc-Inject: <security-definitions> -->
 *
 * API version: 0.8+21-854fde1e4c
 * Contact: hello@vikunja.io
 * Generated by: Swagger Codegen (https://github.com/swagger-api/swagger-codegen.git)
 */

package swagger

type ModelsTeamUser struct {

	// Whether or not the member is an admin of the team. See the docs for more about what a team admin can do
	Admin bool `json:"admin,omitempty"`

	// The users md5-hashed email address, used to get the avatar from gravatar and the likes.
	AvatarUrl string `json:"avatarUrl,omitempty"`

	// A unix timestamp when this task was created. You cannot change this value.
	Created int32 `json:"created,omitempty"`

	// The user's email address.
	Email string `json:"email,omitempty"`

	// The unique, numeric id of this user.
	Id int32 `json:"id,omitempty"`

	// A unix timestamp when this task was last updated. You cannot change this value.
	Updated int32 `json:"updated,omitempty"`

	// The username of the user. Is always unique.
	Username string `json:"username,omitempty"`
}
